# TPK4186 - Advanced Tools for Performance Engineering
# LogisticMap.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

import math

def LogisticMap1(r, x0, n):
  Rs = [(0, x0)]
  x = x0
  for n in range(1, n):
    x = r * x * (1-x)
    Rs.append((n, x))
  return Rs

def LogisticMap2(r, x0, n, k):
  Rs = [(0, x0) for i in range(0, k)]
  x = x0
  for n in range(1, n):
    x = r * x * (1-x)
    Rs.pop(0)
    Rs.append((n, x))
  return Rs

def TestList(Rs, x, epsilon):
  for (i, xi) in Rs:
    if math.fabs(xi-x)<epsilon:
      return True
  return False

def LogisticMap3(r, x0, n, k, epsilon):
  Rs = [(0, x0) for i in range(0, k)]
  x = x0
  for n in range(1, n):
    x = r * x * (1-x)
    found = TestList(Rs, x, epsilon)
    Rs.pop(0)
    Rs.append((n, x))
    if found:
      break
  return Rs

def PrintValues(Rs):
  for (n, x) in Rs:
    print(str(n) + "\t" + str(x))

def PrintValuesAndSlacks(Rs):
  (nl, xl) = Rs[-1]
  for (n, x) in Rs:
    print(str(n) + "\t" + str(x) + "\t" + str(math.fabs(xl-x)))

Rs = LogisticMap3(3.0, 0.7, 10000000, 10, 1.0e-10)
PrintValuesAndSlacks(Rs)

