# TPK4186 - Advanced Tools for Performance Engineering
# Quantiles.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Required modules
import sys
import random

# Creation of the source list
random.seed(12345)
n = 1000
l = 0.0
h = 1.0
m = 0.6
sourceList = [random.triangular(l, h, m) for i in range(0, n)]
# print(sourceList)

# Sort list
sourceList.sort()

# Creation of the bucket list
k = 20
ratio = n/k
print(str(ratio))
maxIndex = ratio
bucketList = []
bucket = []
bucketList.append(bucket)
for i in range(0, n):
  if i+1>maxIndex:
    bucket = []
    bucketList.append(bucket)
    maxIndex += ratio
  bucket.append(sourceList[i])

# Results
print("bucket" + "\t" + "size" + "\t" + "min" + "\t" + "max" + "\t" + "mean")
for index in range(0, k):
  bucket = bucketList[index]
  min = h+1
  max = l-1
  sum = 0
  for value in bucket:
    if value<min:
      min = value
    if value>max:
      max = value
    sum += value
  print(str(index+1) + "\t" + str(len(bucket)) + "\t" + str(min) + "\t" + str(max) + "\t" + str(sum/len(bucket)))
